#if !canImport(ObjectiveC)
import XCTest

extension AbstractInterpreterTests {
    // DO NOT MODIFY: This is autogenerated, use:
    //   `swift test --generate-linuxmain`
    // to regenerate.
    static let __allTests__AbstractInterpreterTests = [
        ("testArrayCreation", testArrayCreation),
        ("testBasicTypeTracking", testBasicTypeTracking),
        ("testBuiltinTypeInference", testBuiltinTypeInference),
        ("testConstructorTypeInference", testConstructorTypeInference),
        ("testFunctionTypes", testFunctionTypes),
        ("testIfElseHandling", testIfElseHandling),
        ("testDeeplyNestedBlocksHandling", testDeeplyNestedBlocksHandling),
        ("testFunctionReassignment", testFunctionReassignment),
        ("testLoopAndFunctionHandling", testLoopAndFunctionHandling),
        ("testMethodTypeInference", testMethodTypeInference),
        ("testObjectTypeTracking", testObjectTypeTracking),
        ("testParameterTypeTracking", testParameterTypeTracking),
        ("testPrimitiveTypesOverride", testPrimitiveTypesOverride),
        ("testPropertyTypeInference", testPropertyTypeInference),
        ("testReassignments", testReassignments),
        ("testReturnTypeInference", testReturnTypeInference),
    ]
}

extension EnvironmentTests {
    // DO NOT MODIFY: This is autogenerated, use:
    //   `swift test --generate-linuxmain`
    // to regenerate.
    static let __allTests__EnvironmentTests = [
        ("testJSEnvironmentConsistency", testJSEnvironmentConsistency),
    ]
}

extension InliningTests {
    // DO NOT MODIFY: This is autogenerated, use:
    //   `swift test --generate-linuxmain`
    // to regenerate.
    static let __allTests__InliningTests = [
        ("testBasicInlining", testBasicInlining),
    ]
}

extension LifterTests {
    // DO NOT MODIFY: This is autogenerated, use:
    //   `swift test --generate-linuxmain`
    // to regenerate.
    static let __allTests__LifterTests = [
        ("testAsyncGeneratorLifting", testAsyncGeneratorLifting),
        ("testBlockStatements", testBlockStatements),
        ("testConsecutiveNestedCodeStrings", testConsecutiveNestedCodeStrings),
        ("testConstantLifting", testConstantLifting),
        ("testDeterministicLifting", testDeterministicLifting),
        ("testDoWhileLifting", testDoWhileLifting),
        ("testFuzzILLifter", testFuzzILLifter),
        ("testLiftingOptions", testLiftingOptions),
        ("testNestedCodeStrings", testNestedCodeStrings),
    ]
}

extension MutationsTests {
    // DO NOT MODIFY: This is autogenerated, use:
    //   `swift test --generate-linuxmain`
    // to regenerate.
    static let __allTests__MutationsTests = [
        ("testInputMutatorRuntimeTypes", testInputMutatorRuntimeTypes),
        ("testPrepareMutationRuntimeTypes", testPrepareMutationRuntimeTypes),
    ]
}

extension ProgramBuilderTests {
    // DO NOT MODIFY: This is autogenerated, use:
    //   `swift test --generate-linuxmain`
    // to regenerate.
    static let __allTests__ProgramBuilderTests = [
        ("testCodeGeneration", testCodeGeneration),
        ("testSplicing1", testSplicing1),
        ("testSplicing2", testSplicing2),
        ("testSplicing3", testSplicing3),
    ]
}

extension ProgramSerializationTests {
    // DO NOT MODIFY: This is autogenerated, use:
    //   `swift test --generate-linuxmain`
    // to regenerate.
    static let __allTests__ProgramSerializationTests = [
        ("testProgramEquality", testProgramEquality),
        ("testProgramInequality", testProgramInequality),
        ("testProtobufSerialization", testProtobufSerialization),
        ("testProtobufSerializationWithOperationCache", testProtobufSerializationWithOperationCache),
        ("testProtobufSerializationWithTypeCache", testProtobufSerializationWithTypeCache),
    ]
}

extension RingBufferTests {
    // DO NOT MODIFY: This is autogenerated, use:
    //   `swift test --generate-linuxmain`
    // to regenerate.
    static let __allTests__RingBufferTests = [
        ("testBasicRingBufferBehaviour", testBasicRingBufferBehaviour),
        ("testRingBufferElementRemoval", testRingBufferElementRemoval),
        ("testRingBufferElementWriteAccess", testRingBufferElementWriteAccess),
        ("testRingBufferIteration", testRingBufferIteration),
    ]
}

extension TypeSystemTests {
    // DO NOT MODIFY: This is autogenerated, use:
    //   `swift test --generate-linuxmain`
    // to regenerate.
    static let __allTests__TypeSystemTests = [
        ("testAnythingAndNothingSubsumption", testAnythingAndNothingSubsumption),
        ("testCallableTypeSubsumption", testCallableTypeSubsumption),
        ("testGeneralization", testGeneralization),
        ("testIsAndMayBe", testIsAndMayBe),
        ("testMethodTypeTransitions", testMethodTypeTransitions),
        ("testObjectGroupSubsumption", testObjectGroupSubsumption),
        ("testObjectInspection", testObjectInspection),
        ("testObjectTypeSubsumption", testObjectTypeSubsumption),
        ("testPrimitiveTypeSubsumption", testPrimitiveTypeSubsumption),
        ("testPropertyTypeTransitions", testPropertyTypeTransitions),
        ("testSignatureTypes", testSignatureTypes),
        ("testSubsumptionAntisymmetry", testSubsumptionAntisymmetry),
        ("testSubsumptionOperators", testSubsumptionOperators),
        ("testSubsumptionReflexivity", testSubsumptionReflexivity),
        ("testSubsumptionTransitivity", testSubsumptionTransitivity),
        ("testTypeDescriptions", testTypeDescriptions),
        ("testTypeEquality", testTypeEquality),
        ("testTypeIntersection", testTypeIntersection),
        ("testTypeMerging", testTypeMerging),
        ("testTypeSerialization", testTypeSerialization),
        ("testTypeUnioning", testTypeUnioning),
        ("testUnknownTypeSubsumption", testUnknownTypeSubsumption),
    ]
}

extension VariableMapTests {
    // DO NOT MODIFY: This is autogenerated, use:
    //   `swift test --generate-linuxmain`
    // to regenerate.
    static let __allTests__VariableMapTests = [
        ("testBasicVariableMapFeatures", testBasicVariableMapFeatures),
        ("testDenseVariableMapForHoles", testDenseVariableMapForHoles),
        ("testEmptyVariableMapForHoles", testEmptyVariableMapForHoles),
        ("testForHolesAfterArbitraryElementRemoval", testForHolesAfterArbitraryElementRemoval),
        ("testForHolesAfterFirstElementRemoval", testForHolesAfterFirstElementRemoval),
        ("testForHolesAfterLastElementRemoval", testForHolesAfterLastElementRemoval),
        ("testVariableMapEncoding", testVariableMapEncoding),
        ("testVariableMapEquality", testVariableMapEquality),
        ("testVariableMapHashing", testVariableMapHashing),
        ("testVariableMapIteration", testVariableMapIteration),
    ]
}

extension VariableSetTests {
    // DO NOT MODIFY: This is autogenerated, use:
    //   `swift test --generate-linuxmain`
    // to regenerate.
    static let __allTests__VariableSetTests = [
        ("testBasicVariableSetFeatures", testBasicVariableSetFeatures),
        ("testVariableSetDisjointTest", testVariableSetDisjointTest),
        ("testVariableSetEquality", testVariableSetEquality),
        ("testVariableSetIntersection", testVariableSetIntersection),
        ("testVariableSetUnion", testVariableSetUnion),
    ]
}

public func __allTests() -> [XCTestCaseEntry] {
    return [
        testCase(AbstractInterpreterTests.__allTests__AbstractInterpreterTests),
        testCase(EnvironmentTests.__allTests__EnvironmentTests),
        testCase(InliningTests.__allTests__InliningTests),
        testCase(LifterTests.__allTests__LifterTests),
        testCase(MutationsTests.__allTests__MutationsTests),
        testCase(ProgramBuilderTests.__allTests__ProgramBuilderTests),
        testCase(ProgramSerializationTests.__allTests__ProgramSerializationTests),
        testCase(RingBufferTests.__allTests__RingBufferTests),
        testCase(TypeSystemTests.__allTests__TypeSystemTests),
        testCase(VariableMapTests.__allTests__VariableMapTests),
        testCase(VariableSetTests.__allTests__VariableSetTests),
    ]
}
#endif
